function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import React, { Component, Children, Fragment } from 'react';
import PropTypes from 'prop-types';
import Column from './Column';
var prefixCls = 'td-box';

var Box =
/*#__PURE__*/
function (_Component) {
  _inherits(Box, _Component);

  function Box(props) {
    var _this;

    _classCallCheck(this, Box);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Box).call(this, props));

    _this.startResize = function (ev, index) {
      // console.log("startResize", e.clientX);
      var moving = true; // 添加开始移动的falg,防止错误触发移动结束事件

      var dx = ev.clientX;

      document.onmousemove = function (e) {
        var moveDis = dx - e.clientX; // 鼠标移动的值 向左是负值， 向右是正值

        _this.panels[index].style.width = "".concat(_this.panelsWidth[index] + moveDis, "px");
        _this.panels[index - 1].style.width = "".concat(_this.panelsWidth[index - 1] - moveDis, "px");
        var onResize = _this.props.onResize;

        var currentWidth = _this.panelsWidth.slice();

        currentWidth[index] = currentWidth[index] + moveDis;
        currentWidth[index - 1] = currentWidth[index - 1] - moveDis;

        if (onResize) {
          onResize(currentWidth);
        }
      };

      document.onmouseup = function (e) {
        if (moving) {
          var moveDis = dx - e.clientX; // 鼠标移动的值 向左是负值， 向右是正值

          _this.panelsWidth[index] = _this.panelsWidth[index] + moveDis;
          _this.panelsWidth[index - 1] = _this.panelsWidth[index - 1] - moveDis; // console.log("onmouseup", this.panelsWidth);

          document.onmousemove = null;
          document.onmouseup = null;
          moving = false;
        }
      };
    };

    _this.panelsWidth = [];
    return _this;
  }

  _createClass(Box, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      if (this.tdbox) {
        this.panels = this.tdbox.getElementsByClassName("".concat(prefixCls, "-panel")); // const panelsWidth = [], panelsDisRight = [];

        Array.prototype.forEach.call(this.panels, function (item) {
          // console.log('map', item.offsetWidth, item.offsetHeight);
          // return item.offsetWidth;
          _this2.panelsWidth.push(item.offsetWidth);
        }); // console.log(this.panelsWidth, this.panelsDisRight);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props = this.props,
          width = _this$props.width,
          _this$props$style = _this$props.style,
          style = _this$props$style === void 0 ? {} : _this$props$style,
          children = _this$props.children,
          onResize = _this$props.onResize;
      return React.createElement("div", {
        className: prefixCls,
        style: _extends(_extends({}, style), {
          width: width
        }),
        ref: function ref(_ref) {
          return _this3.tdbox = _ref;
        }
      }, React.createElement("div", {
        className: "".concat(prefixCls, "-content"),
        style: _extends(_extends({}, style), {
          width: width
        })
      }, Children.map(children, function (child, index) {
        // console.log("child", child);
        return React.createElement(Fragment, {
          key: index
        }, index !== 0 ? React.cloneElement(child, _extends(_extends({}, child.props), {
          dragline: onResize ? React.createElement("div", {
            className: "".concat(prefixCls, "-drag-line"),
            onMouseDown: function onMouseDown(event) {
              return _this3.startResize(event, index);
            }
          }) : null
        }), child.props.children) : child);
      })));
    }
  }]);

  return Box;
}(Component);

Box.Column = Column;
Box.propTypes = {
  onResize: PropTypes.func
};
Box.defaultProps = {};
export default Box;
//# sourceMappingURL=index.js.map
