function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import * as React from 'react';
import Modal from 'antd/es/modal';
import classnames from 'classnames';
var prefixCls = 'td-modal';
var uuid = 0;

function addDrag(props) {
  if (props.draggable) {
    uuid += 1;
    props.className = classnames(props.className, "".concat(prefixCls, "-method-dragable"), "".concat(prefixCls, "-method-dragable-").concat(uuid));
    addMethodEventListener("".concat(prefixCls, "-method-dragable-").concat(uuid));
  }

  return props;
}

function addMethodEventListener(className) {
  var lastMove = 0;
  var canMove = false;
  var initPos;
  var startPos;
  setTimeout(function () {
    var main = document.getElementsByClassName(className);
    var modalBody = main[0];

    if (main && modalBody) {
      if (modalBody instanceof HTMLElement) {
        modalBody.addEventListener('mousedown', function (ev) {
          canMove = true;
          var style = modalBody.style; // const style: CSSStyleDeclaration = modalBody ? modalBody.style : {
          //   left: "0px",
          //   top: "100px",
          // };

          initPos = [style.left ? Number(style.left.replace('px', '')) : 0, style.top ? Number(style.top.replace('px', '')) : 100];
          startPos = [ev.screenX, ev.screenY];
        });
        document.body.addEventListener('mousemove', function (ev) {
          if (canMove) {
            var x = ev.screenX - startPos[0];
            var y = ev.screenY - startPos[1];
            modalBody.style.left = "".concat(x + initPos[0], "px");
            modalBody.style.top = "".concat(y + initPos[1], "px");
            lastMove = Date.now();
          }
        });
        document.body.addEventListener('mouseup', function () {
          canMove = false;
        });
        modalBody.addEventListener('mouseout', function () {
          if (canMove) {
            // 移除区域后
            if (Date.now() - lastMove > 200) {
              console.log('mouseout');
              canMove = false;
            }
          }
        });
      }
    }
  }, 300);
}

var ExtendModal =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ExtendModal, _React$Component);

  function ExtendModal(props) {
    var _this;

    _classCallCheck(this, ExtendModal);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ExtendModal).call(this, props));
    _this.uuid = 0;
    _this.lastMove = 0; // 最近移动时间

    _this.canMove = false; // 鼠标按下，处于可拖动状态

    _this.addEventListener = function () {
      var main = document.getElementsByClassName("".concat(prefixCls, "-dragable-").concat(_this.uuid));
      var modalBody = main[0];

      if (main && modalBody) {
        var header = modalBody.getElementsByClassName('ant-modal-header')[0];

        if (header instanceof HTMLElement) {
          header.addEventListener('mousedown', function (ev) {
            _this.canMove = true; // const style: CSSStyleDeclaration = modalBody ? modalBody.style : {
            //   left: "0px",
            //   top: "0px",
            // };

            var style = modalBody.style;
            _this.initPos = [style.left ? Number(style.left.replace('px', '')) : 0, style.top ? Number(style.top.replace('px', '')) : 0];
            _this.startPos = [ev.screenX, ev.screenY];
          }); // header.addEventListener("mousemove", (ev) => {

          document.body.addEventListener('mousemove', function (ev) {
            if (_this.canMove) {
              var x = ev.screenX - _this.startPos[0];
              var y = ev.screenY - _this.startPos[1];
              modalBody.style.left = "".concat(x + _this.initPos[0], "px");
              modalBody.style.top = "".concat(y + _this.initPos[1], "px");
              _this.lastMove = Date.now();
            }
          });
          document.body.addEventListener('mouseup', function () {
            _this.canMove = false;
          });
          header.addEventListener('mouseout', function () {
            if (_this.canMove) {
              // 移除区域后
              if (Date.now() - _this.lastMove > 200) {
                console.log('mouseout');
                _this.canMove = false;
              }
            }
          });
        }
      }
    };

    _this.uuid = uuid;
    uuid++;
    return _this;
  }

  _createClass(ExtendModal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var draggable = this.props.draggable;

      if (draggable) {}
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var _this2 = this;

      if (nextProps.draggable && nextProps.visible) {
        var main = document.getElementsByClassName("".concat(prefixCls, "-dragable-").concat(this.uuid));

        if (!main[0]) {
          setTimeout(function () {
            _this2.addEventListener();
          }, 300);
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _a = this.props,
          children = _a.children,
          draggable = _a.draggable,
          restProps = __rest(_a, ["children", "draggable"]);

      return draggable ? React.createElement(Modal, _extends({}, restProps, {
        wrapClassName: "".concat(prefixCls, "-dragable-wrap"),
        className: classnames("".concat(prefixCls, "-dragable"), "".concat(prefixCls, "-dragable-").concat(this.uuid)),
        style: {
          left: 100,
          top: 100
        }
      }), children) : React.createElement(Modal, restProps, children);
    }
  }]);

  return ExtendModal;
}(React.Component); // static info: AntdModalFunc;


ExtendModal.info = function (props) {
  var newProps = addDrag(props);
  Modal.info(newProps);
};

ExtendModal.success = function (props) {
  var newProps = addDrag(props);
  return Modal.success(newProps);
};

ExtendModal.error = function (props) {
  var newProps = addDrag(props);
  return Modal.error(newProps);
};

ExtendModal.warn = function (props) {
  var newProps = addDrag(props);
  return Modal.warn(newProps);
};

ExtendModal.warning = function (props) {
  var newProps = addDrag(props);
  return Modal.warning(newProps);
};

ExtendModal.confirm = function (props) {
  var newProps = addDrag(props);
  return Modal.confirm(newProps);
};

ExtendModal.destroyAll = Modal.destroyAll;
export default ExtendModal;
//# sourceMappingURL=index.js.map
