/// <reference types="qs" />
interface Middleware {
    (response: any, option: RequestInit): Promise<any>;
}
/**
 * Requests a URL, returning a promise.
 *
 * @param  {string} url       The URL we want to request
 * @param  {object} [option] The options we want to pass to "fetch"
 * @return {object}           An object containing either "data" or "err"
 */
declare function request(url: string, option?: RequestInit): Promise<any>;
declare namespace request {
    var stringify: typeof import("qs").stringify;
    var use: (cb: Middleware) => void;
}
export default request;
