import _regeneratorRuntime from "@babel/runtime/regenerator";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

import * as React from 'react';
import PropTypes from 'prop-types'; // import s from './style';
// const prefixCls = s.watermarkPrefix;

import domtoimage from 'dom-to-image';
var defaultProps = {
  style: {},
  watermarkStyle: '',
  prefixCls: 'td-watermark',
  text: '',
  color: '#eee',
  font: "italic 14px 'Microsoft YaHei'",
  rotate: -20,
  width: 200,
  height: 150,
  className: '',
  size: ['100%', '100%'],
  type: 'foreground',
  convert: false
};

var Watermark =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Watermark, _React$Component);

  function Watermark(props) {
    var _this;

    _classCallCheck(this, Watermark);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Watermark).call(this, props));
    _this.state = {
      bgImg: '',
      domImg: ''
    };
    _this.canvas = window ? document.createElement('canvas') : null; // 创建画布

    _this.ctx = _this.canvas ? _this.canvas.getContext('2d') : null; // 拿到画笔

    return _this;
  }

  _createClass(Watermark, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.createImg(this.props);

      if (this.props.convert) {
        var _this$props = this.props,
            width = _this$props.width,
            height = _this$props.height,
            convert = _this$props.convert;
        var convertType = convert === 'jpeg' ? domtoimage.toJpeg : domtoimage.toPng;

        if (!window) {
          return;
        }

        convertType(this.container).then(function (dataUrl) {
          return __awaiter(_this2, void 0, void 0,
          /*#__PURE__*/
          _regeneratorRuntime.mark(function _callee() {
            var img, canvas, ctx, xRepeat, yRepeat, mark, x, y;
            return _regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    img = new Image();
                    img.src = dataUrl;
                    _context.next = 4;
                    return img.onload;

                  case 4:
                    canvas = document.createElement('canvas');
                    ctx = canvas.getContext('2d');

                    if (!(!ctx || !this.ctx)) {
                      _context.next = 9;
                      break;
                    }

                    this.setState({
                      domImg: dataUrl
                    });
                    return _context.abrupt("return");

                  case 9:
                    ctx.clearRect(0, 0, width, height);
                    canvas.setAttribute('width', "".concat(img.width));
                    canvas.setAttribute('height', "".concat(img.height));
                    ctx.drawImage(img, 0, 0);
                    xRepeat = Math.ceil(img.width / width);
                    yRepeat = Math.ceil(img.height / height);
                    mark = new Image();
                    mark.src = this.state.bgImg;
                    mark.width = width;
                    mark.height = height;
                    _context.next = 21;
                    return mark.onload;

                  case 21:
                    // console.log(this.props, this.state.bgImg);
                    for (x = 0; x < xRepeat; x++) {
                      for (y = 0; y < yRepeat; y++) {
                        ctx.drawImage(mark, x * width, y * height);
                      }
                    }

                    this.setState({
                      domImg: canvas.toDataURL(convert === 'jpeg' ? 'image/jpeg' : 'image/png')
                    });

                  case 23:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, this);
          }));
        })["catch"](function (error) {
          console.error('oops, something went wrong!', error);
        });
      }
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      this.createImg(nextProps);
    }
  }, {
    key: "createImg",
    value: function createImg(props) {
      var _this3 = this;

      var width = props.width,
          height = props.height,
          text = props.text,
          font = props.font,
          color = props.color,
          rotate = props.rotate,
          img = props.img;

      if (!this.canvas || !this.ctx || !window) {
        return;
      }

      var PI = Math.PI;

      if (text || img) {
        this.canvas.setAttribute('width', "".concat(width));
        this.canvas.setAttribute('height', "".concat(height));
        this.ctx.clearRect(0, 0, width, height);
        this.canvas.style.background = 'transparent';
        this.ctx.rotate(rotate * PI / 180);

        if (text) {
          // this.ctx.textAlign = 'center';
          this.ctx.font = font;
          this.ctx.fillStyle = color;

          var _this$ctx$measureText = this.ctx.measureText(text),
              textWidth = _this$ctx$measureText.width;

          var XPos = (width - textWidth) / 2,
              YPos = height / 2 + 20; // console.log(XPos, YPos);
          // YPos = YPos + textWidth / 2 * sin((-rotate * PI) / 180) ;
          // XPos = XPos + textWidth / 2 * (1 - cos((-rotate * PI) / 180));
          // console.log('textWidth', textWidth, width, this.canvas.toDataURL());
          // console.log(XPos, YPos);

          this.ctx.fillText(text, XPos, YPos); // this.ctx.fillText(text, 100, height / 2);

          this.setState({
            bgImg: this.canvas.toDataURL()
          });
        } else {
          var image = new Image();
          image.setAttribute('crossOrigin', 'Anonymous');

          image.onload = function () {
            if (_this3.ctx) {
              _this3.ctx.drawImage(image, (width - image.width) / 2, (height - image.height) / 2);
            }

            _this3.canvas && _this3.setState({
              bgImg: _this3.canvas.toDataURL()
            });
          };

          image.onerror = function () {
            _this3.setState({
              bgImg: ''
            });
          };

          image.src = img;
        }
      }
    } // renderBackground():React.ReactNode {
    //   const { prefixCls, children, style, className, watermarkStyle, size = [] } = this.props;
    //   const { bgImg } = this.state;
    //   const innerStyle = Object.assign({}, style, watermarkStyle);
    //   if (bgImg) {
    //     innerStyle.backgroundImage = `url(${bgImg})`
    //   }
    //   return (
    //     <div className={`${prefixCls} ${className}`} style={innerStyle} >
    //       {children}
    //     </div>
    //   )
    // }
    // renderForeground():React.ReactNode {
    //   const { prefixCls, children, style, className, watermarkStyle, size = [] } = this.props;
    //   const { bgImg } = this.state;
    //   const innerStyle = Object.assign({ left: 0, top: 0, width: '100%', height: '100%', position: 'absolute' }, watermarkStyle);
    //   if (bgImg) {
    //     innerStyle.backgroundImage = `url(${bgImg})`
    //   }
    //   return (
    //     <div style={Object.assign({
    //       position: 'relative',
    //       width: size[0] || '100%',
    //       height: size[1] || '100%',
    //     }, style)}>
    //       {children}
    //       <div className={`${prefixCls} ${className}`} style={innerStyle} />
    //     </div>
    //   )
    // }

  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$props2 = this.props,
          type = _this$props2.type,
          convert = _this$props2.convert,
          prefixCls = _this$props2.prefixCls,
          children = _this$props2.children,
          style = _this$props2.style,
          className = _this$props2.className,
          watermarkStyle = _this$props2.watermarkStyle,
          _this$props2$size = _this$props2.size,
          size = _this$props2$size === void 0 ? [] : _this$props2$size;
      var _this$state = this.state,
          bgImg = _this$state.bgImg,
          domImg = _this$state.domImg;

      if (convert) {
        // 转化
        return !domImg ? React.createElement("div", {
          ref: function ref(_ref) {
            return _this4.container = _ref;
          }
        }, children) : React.createElement("img", {
          src: "".concat(domImg),
          alt: "convert-to-dom"
        });
      } else {
        // 不转化
        if (type === 'foreground') {
          var innerStyle = _extends({
            left: 0,
            top: 0,
            width: '100%',
            height: '100%',
            position: 'absolute'
          }, watermarkStyle);

          if (bgImg) {
            innerStyle.backgroundImage = "url(".concat(bgImg, ")");
          }

          return React.createElement("div", {
            style: _extends({
              position: 'relative',
              width: size[0] || '100%',
              height: size[1] || '100%'
            }, style)
          }, children, React.createElement("div", {
            className: "".concat(prefixCls, " ").concat(className),
            style: innerStyle
          }));
        } else {
          var _innerStyle = _extends({}, style, watermarkStyle);

          if (bgImg) {
            _innerStyle.backgroundImage = "url(".concat(bgImg, ")");
          }

          return React.createElement("div", {
            className: "".concat(prefixCls, " ").concat(className),
            style: _innerStyle
          }, children);
        }
      }
    }
  }]);

  return Watermark;
}(React.Component);

Watermark.defaultProps = defaultProps;
Watermark.propTypes = {
  text: PropTypes.string,
  color: PropTypes.string,
  font: PropTypes.string,
  rotate: PropTypes.number,
  width: PropTypes.number,
  height: PropTypes.number
};

Watermark.domtoimage = function (dom, type) {
  return __awaiter(void 0, void 0, void 0,
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee2() {
    var convert, dataUrl;
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (!(dom instanceof HTMLElement)) {
              _context2.next = 8;
              break;
            }

            convert = type || String(type) === 'jpeg' ? domtoimage.toJpeg : domtoimage.toPng;
            _context2.next = 4;
            return convert(dom);

          case 4:
            dataUrl = _context2.sent;
            return _context2.abrupt("return", dataUrl);

          case 8:
            return _context2.abrupt("return", '');

          case 9:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
};

function createMarkImg(props) {
  if (!window) {
    return Promise.reject(new Error('window对象不存在'));
  }

  return new Promise(function (resolve) {
    var canvas = document.createElement('canvas');
    var ctx = canvas.getContext('2d');
    var width = props.width,
        height = props.height,
        text = props.text,
        font = props.font,
        color = props.color,
        rotate = props.rotate,
        img = props.img;

    if (!ctx) {
      return resolve('');
    }

    if (text || img) {
      canvas.setAttribute('width', "".concat(width));
      canvas.setAttribute('height', "".concat(height));
      canvas.style.background = 'transparent';
      ctx.rotate(rotate * Math.PI / 180);

      if (text) {
        // ctx.textAlign = 'center';
        ctx.font = font;
        ctx.fillStyle = color; // ctx.fillText(text, width / 2, height / 2);

        var _ctx$measureText = ctx.measureText(text),
            textWidth = _ctx$measureText.width;

        var XPos = (width - textWidth) / 2,
            YPos = height / 2 + 20;
        ctx.fillText(text, XPos, YPos);
        return resolve(canvas.toDataURL());
      } else {
        var image = new Image();
        image.setAttribute('crossOrigin', 'Anonymous');
        image.src = img;

        image.onload = function () {
          if (ctx) {
            ctx.drawImage(image, (width - image.width) / 2, (height - image.height) / 2);
          }

          return resolve(canvas.toDataURL());
        };

        image.onerror = function () {
          return resolve('');
        };
      }
    }
  });
}

var watermarkDOM = function watermarkDOM(dom, options, cb) {
  if (!window) {
    return Promise.reject(new Error('window对象不存在'));
  }

  var mergeOptions = _extends({}, defaultProps, options);

  var convert = mergeOptions.convert,
      width = mergeOptions.width,
      height = mergeOptions.height,
      img = mergeOptions.img,
      text = mergeOptions.text,
      type = mergeOptions.type,
      size = mergeOptions.size,
      prefixCls = mergeOptions.prefixCls,
      className = mergeOptions.className;

  if (dom instanceof HTMLElement) {
    createMarkImg(mergeOptions).then(function (markImgData) {
      var markImg = new Image();
      markImg.src = markImgData;

      if (!convert) {
        if (type === 'foreground') {
          var divElement = document.createElement('div');
          divElement.setAttribute('style', "\n              position: relative;\n              width: ".concat(size[0] || '100%', ";\n              height: ").concat(size[1] || '100%', ";\n            "));
          var markDiv = document.createElement('div');
          markDiv.setAttribute('style', "\n              position: absolute;\n              width: 100%;\n              height: 100%;\n              left: 0;\n              right: 0;\n              background-image: url(".concat(markImgData, ")\n            "));
          markDiv.setAttribute('class', "".concat(prefixCls, " ").concat(className));
          divElement.appendChild(markDiv);
          var parentNode = dom.parentNode;

          if (parentNode) {
            parentNode.removeChild(dom);
            parentNode.appendChild(divElement);
          }

          divElement.appendChild(dom);
        } else {
          dom.style.backgroundImage = " url(".concat(markImgData, ")"); // const markDiv = document.createElement('div');
          // markDiv.setAttribute('style', `
          //     background-image: url(${ markImgData})
          //   `);
          // dom.parentNode && dom.parentNode.replaceChild(markDiv, dom);
          // markDiv.appendChild(dom);
        }
      } else {
        var convertType = convert || String(convert) === 'jpeg' ? domtoimage.toJpeg : domtoimage.toPng;
        convertType(dom).then(function (dataUrl) {
          return __awaiter(void 0, void 0, void 0,
          /*#__PURE__*/
          _regeneratorRuntime.mark(function _callee3() {
            var domImg, canvas, ctx, xRepeat, yRepeat, x, y, markedImg, imgDataUrl;
            return _regeneratorRuntime.wrap(function _callee3$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    domImg = new Image();
                    domImg.src = dataUrl;
                    _context3.next = 4;
                    return domImg.onload;

                  case 4:
                    canvas = document.createElement('canvas');
                    ctx = canvas.getContext('2d');

                    if (ctx) {
                      _context3.next = 8;
                      break;
                    }

                    return _context3.abrupt("return");

                  case 8:
                    canvas.setAttribute('width', "".concat(domImg.width));
                    canvas.setAttribute('height', "".concat(domImg.height));
                    ctx.drawImage(domImg, 0, 0);
                    xRepeat = Math.ceil(domImg.width / width);
                    yRepeat = Math.ceil(domImg.height / height);

                    for (x = 0; x < xRepeat; x++) {
                      for (y = 0; y < yRepeat; y++) {
                        ctx.drawImage(markImg, width * x, height * y);
                      }
                    }

                    markedImg = document.createElement('img');
                    imgDataUrl = canvas.toDataURL(String(convert) === 'jpeg' ? 'image/jpeg' : 'image/png');
                    markedImg.src = imgDataUrl;
                    markedImg.alt = text || img;

                    if (dom.parentNode) {
                      dom.parentNode.replaceChild(markedImg, dom);
                    }

                    if (cb) {
                      cb(imgDataUrl);
                    }

                  case 20:
                  case "end":
                    return _context3.stop();
                }
              }
            }, _callee3);
          }));
        })["catch"](function (error) {
          console.error('oops, something went wrong!', error);
        });
      }
    });
  }
};

Watermark.api = watermarkDOM;
export default Watermark;
//# sourceMappingURL=index.js.map
