import * as React from 'react';
import PropTypes from 'prop-types';
interface Props {
    children: React.ReactChildren;
    value: string | number | undefined;
    defaultValue: string | number | undefined;
    editing: boolean;
    onChange: (value: string) => any;
    onBlur?: (value: string) => any;
    placeholder: string;
    style: React.CSSProperties;
}
interface State {
    editing: boolean;
    value: string | number | undefined;
}
export default class extends React.Component<Props, State> {
    constructor(props: Props);
    input: HTMLInputElement;
    static defaultProps: {
        style: {};
    };
    static propTypes: {
        children: PropTypes.Requireable<PropTypes.ReactElementLike>;
        editing: PropTypes.Requireable<boolean>;
        value: PropTypes.Requireable<React.ReactText>;
        onChange: PropTypes.Requireable<(...args: any[]) => any>;
    };
    UNSAFE_componentWillReceiveProps(nextProps: Props): void;
    componentDidUpdate(_: Props, preState: State): void;
    handleClick: () => void;
    handleBlur: (e: React.ChangeEvent<HTMLInputElement>) => void;
    handleChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
    render(): JSX.Element;
}
export {};
