"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var prefixCls = 'td-editable-input';

function isBoolean(obj) {
  return Object.prototype.toString.call(obj) === '[object Boolean]';
}

function isString(obj) {
  return Object.prototype.toString.call(obj) === '[object String]';
}

var default_1 =
/*#__PURE__*/
function (_React$Component) {
  _inherits(default_1, _React$Component);

  function default_1(props) {
    var _this;

    _classCallCheck(this, default_1);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(default_1).call(this, props));

    _this.handleClick = function () {
      // console.log("handleClick", isBoolean(this.props.editing), this.state.editing);
      if (!isBoolean(_this.props.editing)) {
        _this.setState({
          editing: !_this.state.editing
        });
      }
    };

    _this.handleBlur = function (e) {
      if (!isBoolean(_this.props.editing)) {
        _this.setState({
          editing: false
        });
      }

      _this.props.onBlur && _this.props.onBlur(e.target.value);
    };

    _this.handleChange = function (e) {
      // console.log(e.target.value);
      var _this$props = _this.props,
          value = _this$props.value,
          onChange = _this$props.onChange;

      if (value === undefined) {
        // 不设置value
        _this.setState({
          value: e.target.value
        });
      } else {
        onChange(e.target.value);
      }
    };

    var value = props.value,
        defaultValue = props.defaultValue;
    _this.state = {
      editing: props.editing,
      value: value || defaultValue || ''
    };
    return _this;
  }

  _createClass(default_1, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (nextProps.editing !== this.props.editing) {
        this.setState({
          editing: nextProps.editing
        });
      }

      if (isString(nextProps.value) && nextProps.value !== this.props.value) {
        this.setState({
          value: nextProps.value
        });
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(_, preState) {
      if (this.state.editing && !preState.editing && this.input) {
        // console.log(this.input);
        this.input.focus();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          children = _this$props2.children,
          placeholder = _this$props2.placeholder,
          style = _this$props2.style;
      var _this$state = this.state,
          editing = _this$state.editing,
          value = _this$state.value;
      return editing ? React.createElement("input", {
        style: style,
        className: prefixCls,
        type: "text",
        value: value,
        onChange: this.handleChange,
        onBlur: this.handleBlur,
        ref: function ref(_ref) {
          return _this2.input = _ref;
        },
        placeholder: placeholder
      }) : React.createElement("div", {
        onClick: this.handleClick
      }, children);
    }
  }]);

  return default_1;
}(React.Component);

exports["default"] = default_1;
default_1.defaultProps = {
  style: {}
};
default_1.propTypes = {
  children: _propTypes["default"].element,
  editing: _propTypes["default"].bool,
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  onChange: _propTypes["default"].func
};
//# sourceMappingURL=index.js.map
