import React, { PureComponent, ReactChildren } from 'react';
import { SelectProps as AntdSelectProps } from 'antd/es/select';
export interface IOption {
    label: string;
    value: string | number;
}
export interface Pagination {
    current: number;
    defaultCurrent?: number;
    pageSize: number;
    defaultPageSize?: number;
    children?: Array<ReactChildren>;
    total?: number;
    hideOnSinglePage?: boolean;
    onChange?: Function;
}
export interface SelectProps extends AntdSelectProps {
    options?: IOption[];
    pagination?: Pagination;
}
export interface SelectState {
    pagination?: Pagination;
    popupVisible: boolean;
}
export default class extends PureComponent<SelectProps, SelectState> {
    static Option: React.ClassicComponentClass<import("antd/es/select").OptionProps>;
    static OptGroup: React.ClassicComponentClass<import("antd/es/select").OptGroupProps>;
    changePopupVisible: Function;
    constructor(props: SelectProps);
    UNSAFE_componentWillReceiveProps(nextProps: SelectProps): void;
    lastPage(): void;
    nextPage(): void;
    dropdownRender(child: React.CElement<{
        menuItems: Array<React.ReactNode>;
        visible: boolean;
    }, any>): JSX.Element;
    render(): JSX.Element;
}
