"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _select = _interopRequireDefault(require("antd/es/select"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var Option = _select["default"].Option,
    OptGroup = _select["default"].OptGroup;

function isObject(obj) {
  return Object.prototype.toString.call(obj) === '[object Object]';
}

function isFunction(obj) {
  return Object.prototype.toString.call(obj) === '[object Function]';
}

function isBoolean(obj) {
  return Object.prototype.toString.call(obj) === '[object Boolean]';
}

var defaultPagination = {
  current: 1,
  pageSize: 10
};

var default_1 =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(default_1, _PureComponent);

  function default_1(props) {
    var _this;

    _classCallCheck(this, default_1);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(default_1).call(this, props));
    var initPagination;
    var pagination = props.pagination,
        open = props.open;

    if (pagination && isObject(pagination)) {
      var current = pagination.current,
          defaultCurrent = pagination.defaultCurrent,
          pageSize = pagination.pageSize,
          defaultPageSize = pagination.defaultPageSize,
          _pagination$children = pagination.children,
          children = _pagination$children === void 0 ? [] : _pagination$children,
          total = pagination.total,
          hideOnSinglePage = pagination.hideOnSinglePage;
      initPagination = {
        current: current || defaultCurrent || 1,
        pageSize: pageSize || defaultPageSize || 10,
        total: total || children.length,
        hideOnSinglePage: isBoolean(hideOnSinglePage) ? hideOnSinglePage : true
      };
    }

    _this.state = {
      pagination: initPagination,
      popupVisible: typeof open === 'boolean' ? open : false
    };

    _this.changePopupVisible = function (self) {
      var cacheVisible = false;
      var timer = null;
      var that = self;
      return function () {
        cacheVisible = arguments[0] || cacheVisible;

        if (timer) {
          window.clearTimeout(Number(timer));
        }

        timer = setTimeout(function () {
          that.setState({
            popupVisible: cacheVisible
          });
          cacheVisible = false;
        }, 120); // console.log("arguments", arguments, that, Date.now())s;
      };
    }(_assertThisInitialized(_this));

    _this.dropdownRender = _this.dropdownRender.bind(_assertThisInitialized(_this));
    _this.lastPage = _this.lastPage.bind(_assertThisInitialized(_this));
    _this.nextPage = _this.nextPage.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(default_1, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var pagination = nextProps.pagination;

      if (pagination && isObject(pagination)) {
        var current = pagination.current,
            pageSize = pagination.pageSize,
            _pagination$children2 = pagination.children,
            children = _pagination$children2 === void 0 ? [] : _pagination$children2,
            total = pagination.total;
        var statePagination = this.state.pagination || defaultPagination;
        var newPaginationState = defaultPagination;

        if (current !== statePagination.current) {
          newPaginationState.current = current;
        }

        if (pageSize !== statePagination.pageSize) {
          newPaginationState.pageSize = pageSize;
        }

        if (total !== statePagination.total) {
          newPaginationState.total = total || children.length;
        }

        this.setState({
          pagination: newPaginationState
        });
      }
    }
  }, {
    key: "lastPage",
    value: function lastPage() {
      var _this$state$paginatio = this.state.pagination,
          pagination = _this$state$paginatio === void 0 ? defaultPagination : _this$state$paginatio;

      if (this.props.pagination && isObject(this.props.pagination) && isFunction(this.props.pagination.onChange)) {
        this.props.pagination.onChange && this.props.pagination.onChange(pagination.current - 1, pagination.pageSize);
      } else {
        this.setState({
          pagination: _extends(_extends({}, pagination), {
            current: pagination.current - 1
          })
        });
      }

      this.changePopupVisible(true);
    }
  }, {
    key: "nextPage",
    value: function nextPage() {
      var _this$state$paginatio2 = this.state.pagination,
          pagination = _this$state$paginatio2 === void 0 ? defaultPagination : _this$state$paginatio2;

      if (this.props.pagination && isObject(this.props.pagination) && isFunction(this.props.pagination.onChange)) {
        this.props.pagination.onChange && this.props.pagination.onChange(pagination.current ? pagination.current + 1 : 0, pagination.pageSize);
      } else {
        this.setState({
          pagination: _extends(_extends({}, pagination), {
            current: pagination.current + 1
          })
        });
      }

      this.changePopupVisible(true);
    }
  }, {
    key: "dropdownRender",
    value: function dropdownRender(child) {
      var pagination = this.state.pagination; // const { pagination } = props;
      // console.log('dropdownRender', pagination, child);

      if (pagination && isObject(pagination) && child && child.props.menuItems.length > 0) {
        var current = pagination.current,
            pageSize = pagination.pageSize;
        var total = pagination.total || child.props.menuItems.length;
        var start = (current - 1) * pageSize;
        var end = start + pageSize > total ? total : start + pageSize;
        var showPaginationBtn = total > pageSize;
        var menuItems = [];

        if (total > child.props.menuItems.length) {
          menuItems = child.props.menuItems;
        } else {
          menuItems = child.props.menuItems.slice(start, end);
        }

        return _react["default"].createElement("div", null, current > 1 && showPaginationBtn && _react["default"].createElement("div", {
          className: "pagination-btn",
          onClick: this.lastPage
        }, "\u4E0A\u4E00\u9875"), _react["default"].cloneElement(child, _extends(_extends({}, child.props), {
          menuItems: menuItems,
          visible: true
        })), end < total && showPaginationBtn && _react["default"].createElement("div", {
          className: "pagination-btn",
          onClick: this.nextPage
        }, "\u4E0B\u4E00\u9875"));
      }

      return child;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _a = this.props,
          children = _a.children,
          _a$options = _a.options,
          options = _a$options === void 0 ? [] : _a$options,
          restProps = __rest(_a, ["children", "options"]);

      var popupVisible = this.state.popupVisible;
      return _react["default"].createElement(_select["default"], _extends({}, restProps, {
        dropdownRender: this.dropdownRender,
        onDropdownVisibleChange: function onDropdownVisibleChange(visible) {
          return _this2.changePopupVisible(visible);
        },
        open: popupVisible
      }), children, options.map(function (_ref) {
        var value = _ref.value,
            label = _ref.label;
        return _react["default"].createElement(Option, {
          key: label,
          value: value
        }, label);
      }));
    }
  }]);

  return default_1;
}(_react.PureComponent);

exports["default"] = default_1;
default_1.Option = Option;
default_1.OptGroup = OptGroup;
//# sourceMappingURL=index.js.map
